--
-- HelperAdminGui
-- V1.0.0.0
--
-- @author apuehri
-- @date 06/05/2018
--
-- Copyright (C) apuehri
-- V1.0.0.0 ..... first implementation

haGui = {};
haGui.NameHelperElementM = {};
haGui.NameHelperElementW = {};

local haGui_mt = Class(haGui, ScreenElement);

function haGui:new(target, custom_mt)
    local self = ScreenElement:new(target, haGui_mt);
    self.returnScreenName = "";
    self.currentPageMappingIndex = 1
    self.currentPageId = 1
    self.commands = {}	
    return self;	
end

function haGui:onCreate()
    self.backButton = FocusManager:getElementById("1")
end

function haGui:onCreatePageState(element)
    if self.pageStateElement == nil then
        self.pageStateElement = element
    end
end

function haGui:onOpen()
    haGui:superClass().onOpen(self);

    self:setPageStates()
    self:updatePageStates()
	
	self.pageSelector:setState(1, true)
	haGui.InputNameHelperM = {};
	haGui.InputNameHelperW = {};
end

function haGui:onClose()
    haGui:superClass().onClose(self);
end

function haGui:onClickBack()
    haGui:superClass().onClickBack(self);
	helperadmin:LoadDataGui();
end

function haGui:onClickOk()
    haGui:superClass().onClickOk(self);
	local numNameHe = self.NumHelperElement:getState() + 2;
	if helperadmin.debug then
		print("--- HelperAdminGui Debug ... haGui:onClickOk(numNameHe= "..tostring(numNameHe).. ")");
	end;	
	if (numNameHe ~= nil) then 
		for i = 1, numNameHe, 1 do
			haGui.InputNameHelperM[i] = self.NameHelperElementM[i].elements[1].text;
			haGui.InputNameHelperW[i] = self.NameHelperElementW[i].elements[1].text;
			if helperadmin.debug then
				print("--- HelperAdminGui Debug ... haGui:onClickOk(haGui.InputNameHelperM["..tostring(i).."]= "..tostring(haGui.InputNameHelperM[i]).. ")");
				print("--- HelperAdminGui Debug ... haGui:onClickOk(haGui.InputNameHelperW["..tostring(i).."]= "..tostring(haGui.InputNameHelperW[i]).. ")");				
			end;			
		end			
		helperadmin:UpdHelperFromGui(numNameHe, self.InputNameHelperM, self.InputNameHelperW);
	end;
    -- self:onClickBack();
	haGui:superClass().onClickBack(self);
end

function haGui:onFocusElement(element)
    if element.toolTip ~= nil then
        self:setHelpBoxText(element.toolTip);
		self.ingameMenuInfoBox:setVisible(false);
    end
end

function haGui:onLeaveElement(element)
	self:setHelpBoxText("");
	self.ingameMenuInfoBox:setVisible(true);
end

function haGui:setHelpBoxText(text)
    self.ingameMenuHelpBoxText:setText(text);
    self.ingameMenuHelpBox:setVisible(text ~= "");
end

function haGui:onClickPageSelection(state)
    self.pagingElement:setPage(state)
end

function haGui:onPageChange(pageId, pageMappingIndex)
    self.currentPageId = pageId
    self.currentPageMappingIndex = pageMappingIndex
    self:updatePageStates()
	
    if pageId == haGui.page_ha_GlobSetting then
        self:setNavButtonsFocusChange(FocusManager:getElementById("11"), FocusManager:getElementById("11"))
    elseif pageId == haGui.page_ha_HelperMan then
        self:setNavButtonsFocusChange(FocusManager:getElementById("21"), FocusManager:getElementById("30"))
    elseif pageId == haGui.page_ha_HelperWoman then
        self:setNavButtonsFocusChange(FocusManager:getElementById("31"), FocusManager:getElementById("40"))
    else
        self:setNavButtonsFocusChange(nil, nil)
    end
end


function haGui:onCreatePageHaGlobSetting(element)
    haGui.page_ha_GlobSetting = self.pagingElement:getPageIdByElement(element)
end

function haGui:onCreatePageHelperMan(element)
    haGui.page_ha_HelperMan = self.pagingElement:getPageIdByElement(element)
end

function haGui:onCreatePageHelperWoman(element)
    haGui.page_ha_HelperWoman = self.pagingElement:getPageIdByElement(element)
end


function haGui:updatePageStates()
    for index, state in pairs(self.pageStateBox.elements) do
        if index == self.pageSelector:getState() then
            state.state = GuiOverlay.STATE_FOCUSED
        else
            state.state = GuiOverlay.STATE_NORMAL
        end
    end
	if helperadmin.debug then
		print("--- HelperAdminGui Debug ... haGui:updatePageStates wird ausgeführt, pageId ="..tostring(self.currentPageId).. ")");
	end;
	if (self.currentPageId == 1) then
		for i = ((helperadmin.minHelper / 2) + 1), (helperadmin.maxHelper / 2), 1 do
			self.NameHelperElementM[i].visible = false;
			self.NameHelperElementW[i].visible = false;			
		end
	end	
	if (self.currentPageId >= 2) and (self.currentPageId <= 3) then
		local helpindex = self.NumHelperElement:getState() + 2;
		if helperadmin.debug then
			print("--- HelperAdminGui Debug ... haGui:updatePageStates(helpindex= "..tostring(helpindex).. ")");
		end;			
		for i = 1, helpindex, 1 do
			self.NameHelperElementM[i].visible = true;
			self.NameHelperElementW[i].visible = true;
		end
	end
end

function haGui:onPageUpdate()
    self:setPageStates()
end

function haGui:setPageStates()
    for i = #self.pageStateBox.elements, 1, -1 do
        self.pageStateBox.elements[i]:delete()
    end
    local texts = self.pagingElement:getPageTitles()
    for _, _ in pairs(texts) do
        self.pageStateElement:clone(self.pageStateBox)
    end
    self.pageSelector:setTexts(texts)
    self.pageStateBox:invalidateLayout()
    self.pageSelector:setDisabled(#texts == 1)
end

function haGui:setNavButtonsFocusChange(targetElementTop, targetElementBottom)
	if targetElementTop ~= nil and targetElementBottom ~= nil then
		local buttonBack = FocusManager:getElementById("1")
		local pageSelector = FocusManager:getElementById("3")
		buttonBack.focusChangeData[FocusManager.TOP] = targetElementBottom.focusId
		pageSelector.focusChangeData[FocusManager.BOTTOM] = targetElementTop.focusId
	end

	local focusElement = FocusManager:getFocusedElement()
	if focusElement ~= nil then
		FocusManager:unsetFocus(focusElement)
		FocusManager:setFocus(focusElement)
	end
end

function haGui:onCreateNumHelper(element)
    self.NumHelperElement = element;
    local countHelper = {};
	local startval = helperadmin.minHelper
	local maxcount = ((helperadmin.maxHelper - startval) / 2) + 1;
	
    for i = 1, maxcount, 1 do
        countHelper[i] = tostring(startval);
		startval = startval + 2;	
    end
    element:setTexts(countHelper);
end

function haGui:onCreateTextInputHeM1(element)
	self.NameHelperElementM[1] = element;	
end

function haGui:onCreateTextInputHeM2(element)
    self.NameHelperElementM[2] = element;	
end

function haGui:onCreateTextInputHeM3(element)
    self.NameHelperElementM[3] = element;
end

function haGui:onCreateTextInputHeM4(element)
    self.NameHelperElementM[4] = element;
end

function haGui:onCreateTextInputHeM5(element)
    self.NameHelperElementM[5] = element;
end

function haGui:onCreateTextInputHeM6(element)
    self.NameHelperElementM[6] = element;
end

function haGui:onCreateTextInputHeM7(element)
    self.NameHelperElementM[7] = element;
end

function haGui:onCreateTextInputHeM8(element)
    self.NameHelperElementM[8] = element;
end

function haGui:onCreateTextInputHeM9(element)
    self.NameHelperElementM[9] = element;
end

function haGui:onCreateTextInputHeM10(element)
    self.NameHelperElementM[10] = element;
end

function haGui:onCreateTextInputHeW1(element)
	self.NameHelperElementW[1] = element;
end

function haGui:onCreateTextInputHeW2(element)
    self.NameHelperElementW[2] = element;	
end

function haGui:onCreateTextInputHeW3(element)
    self.NameHelperElementW[3] = element;
end

function haGui:onCreateTextInputHeW4(element)
    self.NameHelperElementW[4] = element;
end

function haGui:onCreateTextInputHeW5(element)
    self.NameHelperElementW[5] = element;
end

function haGui:onCreateTextInputHeW6(element)
    self.NameHelperElementW[6] = element;
end

function haGui:onCreateTextInputHeW7(element)
    self.NameHelperElementW[7] = element;
end

function haGui:onCreateTextInputHeW8(element)
    self.NameHelperElementW[8] = element;
end

function haGui:onCreateTextInputHeW9(element)
    self.NameHelperElementW[9] = element;
end

function haGui:onCreateTextInputHeW10(element)
    self.NameHelperElementW[10] = element;
end

function haGui:setNumHelper(ActNumHelper)
	local index = ((ActNumHelper - helperadmin.minHelper) / 2) + 1;
	if helperadmin.debug then
		print("--- HelperAdminGui Debug ... haGui:setNumHelper(ActNumHelper= "..tostring(ActNumHelper).. " ,index= " ..tostring(index).. ")");
	end;	
    self.NumHelperElement:setState(index, false);	
end

function haGui:setNameHelper(number, name, gender)
	if (number ~= nil) and (name ~= nil) and (gender ~= nil) then
		if (gender == 1) then --man
			self.NameHelperElementM[number].elements[1]:setText(name);
		elseif (gender == 2) then --woman
			self.NameHelperElementW[number].elements[1]:setText(name);
		end;
	end;	
end

